package initialization

import (
	"fmt"
	"gitee.com/golang-module/carbon/v2"
	"github.com/robfig/cron/v3"
	"log"
	"testData/global"
	"testData/repository"
	test_data "testData/repository/test.data"
)

func InitCronListCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	//_, err := c.AddFunc("0 */1 * * *", func() {
	_, err := c.AddFunc("*/10 * * * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "CronListCron start")
		test_data.CronWaferList()
		test_data.CronABList()
		test_data.CronBPList()
		test_data.CronCPList()
		test_data.CronFTList()
		test_data.CronTRList()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "CronListCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitCronListCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitCronCheckListCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	//_, err := c.AddFunc("0 */1 * * *", func() {
	_, err := c.AddFunc("0 0 */1 * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "CronCheckListCron start")
		test_data.CronCheckCPList()
		//test_data.CronCheckFTList()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "CronCheckListCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitCronCheckListCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitEmailCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	//_, err := c.AddFunc("0 */1 * * *", func() {
	_, err := c.AddFunc("*/30 * * * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "EmailCron start")
		repository.Emails()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "EmailCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitEmailCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitTestFilesHandlerCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	_, err := c.AddFunc("*/30 * * * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "TestFilesHandlerCron start")
		repository.TestFilesHandlerCron()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "TestFilesHandlerCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitTestFilesHandlerCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitWeekExportFTCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	_, err := c.AddFunc("25 8 * * 1", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "WeekExportFTCron start")
		test_data.WeekExportFTCron()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "WeekExportFTCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitWeekExportFTCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitMonthExportFTCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	_, err := c.AddFunc("25 8 1 * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "MonthExportFTCron start")
		test_data.MonthExportFTCron()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "MonthExportFTCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitMonthExportFTCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}

func InitAutoDeleteUploadFilesCron() {
	c := cron.New(cron.WithChain(cron.SkipIfStillRunning(cron.DefaultLogger)))
	_, err := c.AddFunc("* * * * *", func() {
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "AutoDeleteUploadFilesCron start")
		test_data.AutoDeleteUploadFiles()
		fmt.Println(carbon.Now().Format("Y-m-d H:i:s") + "AutoDeleteUploadFilesCron finish")
	})
	if err != nil {
		global.Log.Errorf("InitAutoDeleteUploadFilesCron AddFunc error: %s", err)
		log.Fatalln(err)
	}
	c.Start()
}
